package cn.com.infosec.asn1.ocsp;

import cn.com.infosec.asn1.ASN1Choice;
import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERNull;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERTaggedObject;

public class CertStatus extends ASN1Encodable implements ASN1Choice {
   private int tagNo;
   private DEREncodable value;

   public CertStatus() {
      CertStatus var10000 = this;
      super();
      this.tagNo = 0;
      DERNull var1;
      var1 = new DERNull.<init>();
      var10000.value = var1;
   }

   public CertStatus(RevokedInfo info) {
      this.tagNo = 1;
      this.value = info;
   }

   public CertStatus(int tagNo, DEREncodable value) {
      this.tagNo = tagNo;
      this.value = value;
   }

   public CertStatus(ASN1TaggedObject choice) {
      this.tagNo = choice.getTagNo();
      CertStatus var10000;
      int var2;
      DERNull var3;
      if ((var2 = choice.getTagNo()) != 0) {
         if (var2 != 1) {
            if (var2 == 2) {
               var10000 = this;
               var3 = new DERNull.<init>();
               var10000.value = var3;
            }
         } else {
            this.value = RevokedInfo.getInstance(choice, false);
         }
      } else {
         var10000 = this;
         var3 = new DERNull.<init>();
         var10000.value = var3;
      }

   }

   public static CertStatus getInstance(Object obj) {
      if (obj != null && !(obj instanceof CertStatus)) {
         if (obj instanceof ASN1TaggedObject) {
            return new CertStatus((ASN1TaggedObject)obj);
         } else {
            throw new IllegalArgumentException("unknown object in factory: " + obj.getClass().getName());
         }
      } else {
         return (CertStatus)obj;
      }
   }

   public static CertStatus getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(obj.getObject());
   }

   public int getTagNo() {
      return this.tagNo;
   }

   public DEREncodable getStatus() {
      return this.value;
   }

   public DERObject toASN1Object() {
      CertStatus var10002 = this;
      int var2 = this.tagNo;
      DEREncodable var1 = var10002.value;
      return new DERTaggedObject(false, var2, var1);
   }
}
